Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 1102)
@@ -19,18 +19,4 @@
 package org.expeditee.items;
 
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Cursor;
-import java.awt.GradientPaint;
-import java.awt.Graphics2D;
-import java.awt.Point;
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.Shape;
-import java.awt.Stroke;
-import java.awt.geom.AffineTransform;
-import java.awt.geom.Area;
-import java.awt.geom.Point2D;
-import java.awt.geom.Rectangle2D;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -46,11 +32,24 @@
 import org.expeditee.actions.Misc;
 import org.expeditee.actions.Simple;
+import org.expeditee.core.Anchoring;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Cursor;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Fill;
+import org.expeditee.core.GradientFill;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.Bounds;
+import org.expeditee.core.bounds.EllipticalBounds;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
 import org.expeditee.gui.AttributeValuePair;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameKeyboardActions;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.gui.FreeItems;
@@ -75,161 +74,313 @@
 public abstract class Item implements Comparable<Item>, Runnable {
 
-	public static final Float DEFAULT_THICKNESS = 2f;
-
-	public static final Float MINIMUM_THICKNESS = 0f;
-
-	public static final Float MINIMUM_PAINT_THICKNESS = 1f;
-
-	protected final int JOIN = BasicStroke.JOIN_ROUND;
-
-	protected final int CAP = BasicStroke.CAP_BUTT;
-
-	protected final Stroke DOT_STROKE = new BasicStroke(DEFAULT_THICKNESS,
-			CAP, JOIN, 4.0F);
-
-	protected final Stroke HIGHLIGHT_STROKE = new BasicStroke(
-			MINIMUM_THICKNESS, CAP, JOIN, 4.0F);
-
-	// contains all dots (including this one) that form an enclosure
-	// if this dot is part of an enclosing shape
-	private Collection<Item> _enclosure = null;
-
-	public static final int LEFT_MARGIN = 13;
-
-	// indicates which end the arrowhead should be drawn at
-	protected Polygon _poly = null;
-
-	protected boolean _connectedToAnnotation = false;
-
-	protected boolean _save = true;
-
-	private int _gradientAngle = 0;
-
-	public static final int NEAR_DISTANCE = 15;
-
-	/**
-	 * The default Color to draw highlighting in
-	 */
-	public static final int DEFAULT_HIGHLIGHT_THICKNESS = 2;
-
-	public static final Color DEFAULT_HIGHLIGHT = Color.RED;
-
-	public static final Color DEPRESSED_HIGHLIGHT = Color.GREEN;
-
-	public static final Color ALTERNATE_HIGHLIGHT = Color.BLUE;
-
-	public static final Color LINK_COLOR = Color.BLACK;
-
-	public static final Color ACTION_COLOR = Color.BLACK;
-
-	public static final Color LINK_ACTION_COLOR = Color.RED;
-
-	public static final Color DEFAULT_FOREGROUND = Color.BLACK;
-
-	public static final Color DEFAULT_BACKGROUND = Color.white;
-
-	public static final Color TRANSPARENT = new Color(0, 0, 0, 0);
-
-	/**
-	 * The number of pixels highlighting should extend around Items.
-	 */
-	public static final int XGRAVITY = 3;
-
-	public static final int MARGIN_RIGHT = 2;
-
-	public static final int MARGIN_LEFT = 15;
-
-	protected static final double DEFAULT_ARROWHEAD_RATIO     = 0.3; // used to be 0.5
-
-	public static final double DEFAULT_ARROWHEAD_NIB_PERC  = 0.75; 
-	
-	public static final Color GREEN = Color.GREEN.darker();
-
-	public static final int UNCHANGED_CURSOR = -100;
-
-	public static final int DEFAULT_CURSOR = Cursor.DEFAULT_CURSOR;
-
-	public static final int HIDDEN_CURSOR = Cursor.CUSTOM_CURSOR;
-
-	public static final int TEXT_CURSOR = Cursor.TEXT_CURSOR;
-
-	public static final int CROP_CURSOR = Cursor.CROSSHAIR_CURSOR;
-
-	// The default value for integer attributes
-	public static final int DEFAULT_INTEGER = -1;
-
-	protected DotType _type = DotType.square;
-
-	protected boolean _filled = true;
-	
-	private Tooltip _tooltip = new Tooltip();
-
+	public enum HighlightMode {
+		None, // The item has no highlighting
+		Enclosed, // The item is part of the current enclosure
+		Connected, // The item is connected to the current item
+		Disconnect, // The item is a free item
+		Normal // The item is the current item
+	}
+
+	/** Which edge of the window things are anchored to. */
 	public enum AnchorEdgeType {
 		None, Left, Right, Top, Bottom
 	}
-
-	public static void DuplicateItem(Item source, Item dest) {
-		dest.setX(source.getX());
-		dest.setY(source.getY());
-
-		dest.setActions(source.getAction());
-		dest.setActionCursorEnter(source.getActionCursorEnter());
-		dest.setActionCursorLeave(source.getActionCursorLeave());
-		dest.setActionEnterFrame(source.getActionEnterFrame());
-		dest.setActionLeaveFrame(source.getActionLeaveFrame());
-		dest.setActionMark(source.getActionMark());
-
-		dest.setBackgroundColor(source.getBackgroundColor());
-		dest.setBottomShadowColor(source.getBottomShadowColor());
-		dest.setColor(source.getColor());
-		dest.setBorderColor(source.getBorderColor());
-
-		dest.setTooltips(source.getTooltip());
-		dest.setData(source.getData());
-		dest.setTag(source.getTag());
-		dest.setFillColor(source.getFillColor());
-		dest.setGradientColor(source.getGradientColor());
-		dest.setGradientAngle(source.getGradientAngle());
-		dest.setFillPattern(source.getFillPattern());
-
-		dest.setHighlight(source.getHighlight());
-		dest.setLink(source.getLink());
-		dest.setLinkFrameset(source.getLinkFrameset());
-		dest.setLinkMark(source.getLinkMark());
-		dest.setLinkTemplate(source.getLinkTemplate());
-
-		// dest.setMaxWidth(source.getMaxWidth());
-
-		dest.setOffset(source.getOffset());
-		// dest.setOwner(source.getOwner());
-		dest.setThickness(source.getThickness());
-		dest.setSize(source.getSize());
-		dest.setTopShadowColor(source.getTopShadowColor());
-		dest.setLinePattern(source.getLinePattern());
-
-		dest.setFloating(source.isFloating());
-		dest.setArrow(source.getArrowheadLength(), source.getArrowheadRatio(), source.getArrowheadNibPerc());
-
-		dest.setDotType(source.getDotType());
-		dest.setFilled(source.getFilled());
+	
+	public static final float SIZE_NOT_APPLICABLE = Float.NaN;
+	
+	public static final Float DEFAULT_THICKNESS = 2f;
+
+	public static final Float MINIMUM_THICKNESS = 0f;
+
+	public static final Float MINIMUM_PAINT_THICKNESS = 1f;
+
+	protected static final Stroke.JOIN DEFAULT_JOIN = Stroke.JOIN.ROUND;
+
+	protected static final Stroke.CAP DEFAULT_CAP = Stroke.CAP.BUTT;
+
+	protected static final Stroke DOT_STROKE = new Stroke(DEFAULT_THICKNESS, DEFAULT_CAP, DEFAULT_JOIN);
+
+	protected static final Stroke HIGHLIGHT_STROKE = new Stroke(MINIMUM_THICKNESS, DEFAULT_CAP, DEFAULT_JOIN);
+	
+	public static final int LEFT_MARGIN = 13;
+
+	public static final int NEAR_DISTANCE = 15;
+
+	public static final int DEFAULT_HIGHLIGHT_THICKNESS = 2;
+
+	/** The default colour to draw highlighting in */
+	public static final Colour DEFAULT_HIGHLIGHT = Colour.RED;
+
+	public static final Colour DEPRESSED_HIGHLIGHT = Colour.GREEN;
+
+	public static final Colour ALTERNATE_HIGHLIGHT = Colour.BLUE;
+
+	public static final Colour LINK_COLOR = Colour.BLACK;
+
+	public static final Colour ACTION_COLOR = Colour.BLACK;
+
+	public static final Colour LINK_ACTION_COLOR = Colour.RED;
+
+	public static final Colour DEFAULT_FOREGROUND = Colour.BLACK;
+
+	public static final Colour DEFAULT_BACKGROUND = Colour.WHITE;
+
+	public static final Colour TRANSPARENT = new Colour(0, 0, 0, 0);
+
+	/** The number of pixels highlighting should extend around Items. */
+	public static final int XGRAVITY = 3;
+
+	public static final int MARGIN_RIGHT = 2;
+
+	public static final int MARGIN_LEFT = 15;
+
+	protected static final double DEFAULT_ARROWHEAD_RATIO = 0.3; // used to be 0.5
+
+	public static final double DEFAULT_ARROWHEAD_NIB_PERC  = 0.75;
+	
+	public static final Colour GREEN = Colour.GREEN.darker();
+
+	//public static final int UNCHANGED_CURSOR = -100;
+
+	public static final Cursor.CursorType DEFAULT_CURSOR = Cursor.CursorType.DEFAULT;
+
+	public static final Cursor.CursorType HIDDEN_CURSOR = Cursor.CursorType.CUSTOM;
+
+	public static final Cursor.CursorType TEXT_CURSOR = Cursor.CursorType.TEXT;
+
+	public static final Cursor.CursorType CROP_CURSOR = Cursor.CursorType.CROSSHAIR;
+
+	/** The default value for integer attributes */
+	public static final int DEFAULT_INTEGER = -1;
+
+	private static final int BRIGHTNESS = 185;
+
+	/** Contains all dots (including this one) that form an enclosure if this dot is part of an enclosing shape. */
+	private Collection<Item> _enclosure = null;
+
+	/** The area which this item covers (including its gravity). */
+	private Bounds _bounds = null;
+	
+	/** The area this item covered before it was invalidated. */
+	private Bounds _oldBounds = null;
+
+	protected boolean _connectedToAnnotation = false;
+
+	protected boolean _save = true;
+
+	/** The angle of change for gradient colour fills (in radians). */
+	private double _gradientAngle = 0.0;
+	
+	private Tooltip _tooltip = new Tooltip();
+
+	protected Anchoring _anchoring = new Anchoring();
+
+	/** The highlight mode for this item. */
+	protected HighlightMode _highlightMode = HighlightMode.None;
+
+	private Point _offset = new Point(0, 0);
+
+	protected float _x;
+	protected float _y;
+
+	private int _id;
+
+	private Item _editTarget = this;
+
+	private String _creationDate = null;
+
+	/** Whether or not this item should display a mark indicating it has a link. */
+	private boolean _linkMark = true;
+
+	/** Whether or not this item should display a mark indicating it has an action. */
+	private boolean _actionMark = true;
+
+	/** TODO: Appears unused? cts16 */
+	private boolean _highlight = true;
+
+	// private int _maxWidth = -1;
+
+	private String _owner = null;
+
+	private String _link = null;
+	
+	private boolean _linkHistory = true;
+
+	private StringBuffer _tag = new StringBuffer();
+
+	private List<String> _actionCursorEnter = null;
+
+	private List<String> _actionCursorLeave = null;
+
+	private List<String> _actionEnterFrame = null;
+
+	private List<String> _actionLeaveFrame = null;
+
+	private PermissionPair _permissionPair = null;
+	
+	private UserAppliedPermission _overlayPermission = null;
+
+	/** The primary fill colour of this item. A fill colour of null represents transparent. */
+	private Colour _fillColour = null;
+
+	/** The secondary fill colour if this item has a gradient fill. Null represents no gradient. */
+	private Colour _gradientColour = null;
+
+	/** The primary draw colour of this item. Null represents the default colour. */
+	private Colour _foregroundColour = null;
+
+	/** The colour to draw highlights on this item. */
+	protected Colour _highlightColour = DEFAULT_HIGHLIGHT;
+
+	/** The background colour for this item. */
+	private Colour _backgroundColour = null;
+
+	private Colour _colorBorder = null;
+
+	private Colour _colorTopShadow = null;
+
+	private Colour _colorBottomShadow = null;
+
+	/** The shape representing the circle drawn next to link/action items. */
+	private static EllipticalBounds _linkCircle = null;
+
+	/** The shape representing the cross drawn next to invalid links. */ 
+	private static PolygonBounds _linkCircleCross = null;
+
+	private Frame _parent = null;
+	private Frame _oldParent = null;
+
+	protected int _highlightThickness = 2;
+
+	protected int _vectorHighlightThickness = 1;
+
+	// arrowhead parameters
+	private float  _arrowheadLength  = 0;
+	private double _arrowheadRatio   = DEFAULT_ARROWHEAD_RATIO;
+	private double _arrowheadNibPerc = DEFAULT_ARROWHEAD_NIB_PERC;
+	
+	private PolygonBounds _arrowhead = null;
+
+	// the list of lines that this point is part of.
+	private List<Line> _lines = new ArrayList<Line>();
+
+	private int[] _linePattern = null;
+
+	private boolean _floating = false;
+
+	// list of points constrained with this point
+	private List<Constraint> _constraints = new ArrayList<Constraint>();
+
+	private List<String> _actions = null;
+
+	private List<String> _data = null;
+
+	private String _formula = null;
+
+	private String _link_frameset = null;
+
+	private String _link_template = null;
+
+	private String _fillPattern = null;
+
+	private boolean _visible = true;
+
+	private float _thickness = -1.0F;
+
+	protected Collection<XRayable> _enclosures = new HashSet<XRayable>();
+
+	private boolean _deleted = false;
+
+	private Overlay _overlay = null;
+
+	protected AttributeValuePair _attributeValuePair = null;
+
+	private Float _autoStamp = null;
+	
+	private Item _magnetizedItemLeft = null;
+	
+	private Item _magnetizedItemRight = null;
+	
+	private Item _magnetizedItemTop = null;
+	
+	private Item _magnetizedItemBottom = null;
+
+	protected DotType _type = DotType.square;
+
+	protected boolean _filled = true;
+
+	/** Just calls source.duplicateOnto(dest). */
+	public static void DuplicateItem(Item source, Item dest)
+	{
+		if (source == null) return;
+		
+		source.duplicateOnto(dest);
+	}
+	
+	/** Sets the properties of dest so that they match this item's properties. */
+	public void duplicateOnto(Item dest)
+	{
+		if (dest == null) return;
+		
+		dest.setX(this.getX());
+		dest.setY(this.getY());
+
+		dest.setActions(this.getAction());
+		dest.setActionCursorEnter(this.getActionCursorEnter());
+		dest.setActionCursorLeave(this.getActionCursorLeave());
+		dest.setActionEnterFrame(this.getActionEnterFrame());
+		dest.setActionLeaveFrame(this.getActionLeaveFrame());
+		dest.setActionMark(this.getActionMark());
+
+		dest.setBackgroundColor(this.getBackgroundColor());
+		dest.setBottomShadowColor(this.getBottomShadowColor());
+		dest.setColor(this.getColor());
+		dest.setBorderColor(this.getBorderColor());
+
+		dest.setTooltips(this.getTooltip());
+		dest.setData(this.getData());
+		dest.setTag(this.getTag());
+		dest.setFillColor(this.getFillColor());
+		dest.setGradientColor(this.getGradientColor());
+		dest.setGradientAngle(this.getGradientAngle());
+		dest.setFillPattern(this.getFillPattern());
+
+		dest.setHighlight(this.getHighlight());
+		dest.setLink(this.getLink());
+		dest.setLinkFrameset(this.getLinkFrameset());
+		dest.setLinkMark(this.getLinkMark());
+		dest.setLinkTemplate(this.getLinkTemplate());
+
+		// dest.setMaxWidth(this.getMaxWidth());
+
+		dest.setOffset(this.getOffset());
+		// dest.setOwner(this.getOwner());
+		dest.setThickness(this.getThickness());
+		dest.setSize(this.getSize());
+		dest.setTopShadowColor(this.getTopShadowColor());
+		dest.setLinePattern(this.getLinePattern());
+
+		dest.setFloating(this.isFloating());
+		dest.setArrow(this.getArrowheadLength(), this.getArrowheadRatio(), this.getArrowheadNibPerc());
+		dest.setDotType(this.getDotType());
+		dest.setFilled(this.getFilled());
 		/*
 		 * Calling the methods will move the item... This messes things up when
 		 * the user uses backspace to delete a text line end
 		 */
-		// dest._anchorLeft = source._anchorLeft;
-		// dest._anchorRight = source._anchorRight;
-		// dest._anchorTop = source._anchorTop;
-		// dest._anchorBottom = source._anchorBottom;
-		dest.setFormula(source.getFormula());
-		dest._overlay = source._overlay;
-		dest._mode = source._mode;// SelectedMode.None;
-		// dest._highlightColor = source._highlightColor;
-		// dest.setHighlight(source.getHighlight());
-
-		dest._visible = source._visible;
-
-		Frame parent = DisplayIO.getCurrentFrame();
-		if (parent == null)
-			parent = source.getParentOrCurrentFrame();
+		// dest._anchorLeft = this._anchorLeft;
+		// dest._anchorRight = this._anchorRight;
+		// dest._anchorTop = this._anchorTop;
+		// dest._anchorBottom = this._anchorBottom;
+		dest.setFormula(this.getFormula());
+		dest._overlay = this._overlay;
+		dest._highlightMode = this._highlightMode;// SelectedMode.None;
+		// dest._highlightColor = this._highlightColor;
+		// dest.setHighlight(this.getHighlight());
+
+		dest._visible = this._visible;
+
+		Frame parent = DisplayController.getCurrentFrame();
+		if (parent == null) parent = this.getParentOrCurrentFrame();
 		dest.setParent(parent);
 
@@ -246,12 +397,39 @@
 		}
 	}
-
-	public void setGradientAngle(int gradientAngle) {
+	
+	public void setDotType(DotType type) {
+		invalidateAll();
+		_type = type;
+		invalidateAll();
+	}
+
+	public DotType getDotType() {
+		return _type;
+	}
+
+	
+	public void setFilled(boolean filled)
+	{
+		invalidateAll();
+		_filled = filled;
+		invalidateAll();
+	}
+
+	public boolean getFilled() {
+		return _filled;
+	}
+
+	/**
+	 * Sets the angle of colour change for gradient colour fills.
+	 * 
+	 * @param gradientAngle The new angle of colour change.
+	 */
+	public void setGradientAngle(double gradientAngle)
+	{
 		_gradientAngle = gradientAngle;
 
 		for (Line line : _lines) {
 			Item other = line.getOppositeEnd(this);
-			if (other.getGradientAngle() != gradientAngle)
-				other.setGradientAngle(gradientAngle);
+			if (other.getGradientAngle() != gradientAngle) other.setGradientAngle(gradientAngle);
 		}
 
@@ -260,79 +438,59 @@
 	}
 
-	public int getGradientAngle() {
+	/**
+	 * Gets the angle of colour change for gradient fills.
+	 * 
+	 * @return The angle of colour change.
+	 */
+	public double getGradientAngle() {
 		return _gradientAngle;
 	}
 
-	public int getGravity() {
-		if (isVectorItem()) {
-			return 2;
-		}
+	/**
+	 * Gets the gravity for this item. Gravity is the distance from the item at which mouse interaction
+	 * applies to the item (like a small buffer zone so you don't need to click exactly on the item).
+	 * 
+	 * @return The gravity distance for this item.
+	 */
+	public int getGravity()
+	{
+		if (isVectorItem()) return 2;
+		
 		return UserSettings.Gravity.get();
 	}
 
-	public static boolean showLineHighlight() {
+	/**
+	 * Whether or not line highlights should be shown.
+	 * TODO: Not really an item method is it? Goes straight to user settings. Refactor. cts16
+	 * 
+	 * @return <code>true</code> if line highlighting should be shown, <code>false</code> otherwise.
+	 */
+	public static boolean shouldShowLineHighlight()
+	{
 		return UserSettings.LineHighlight.get();
 	}
 
-	public enum HighlightMode {
-		None, Enclosed, Connected, Disconnect, Normal
-	}
-
-	public void setHighlightMode(HighlightMode mode) {
-		setHighlightMode(mode, DEFAULT_HIGHLIGHT);
-	}
-
-	protected Float _anchorLeft = null;
-	protected Float _anchorRight = null;
-
-	protected Float _anchorTop = null;
-	protected Float _anchorBottom = null;
-
-	protected HighlightMode _mode = HighlightMode.None;
-
-	private Point _offset = new Point(0, 0);
-
-	protected float _x;
-	protected float _y;
-
-	private int _id;
-
-	private Item _editTarget = this;
-
-	private String _creationDate = null;
-
-	private boolean _linkMark = true;
-
-	private boolean _actionMark = true;
-
-	private boolean _highlight = true;
-
-	// private int _maxWidth = -1;
-
-	private String _owner = null;
-
-	private String _link = null;
-	
-	private boolean _linkHistory = true;
-
-	private StringBuffer _tag = new StringBuffer();
-
-	private List<String> _actionCursorEnter = null;
-
-	private List<String> _actionCursorLeave = null;
-
-	private List<String> _actionEnterFrame = null;
-
-	private List<String> _actionLeaveFrame = null;
-
-	private PermissionPair _permissionPair = null;
-	
-	private UserAppliedPermission _overlayPermission = null;
-	
-	public void setOverlayPermission(UserAppliedPermission overlayPermission) {
+	/**
+	 * Sets the highlight mode for this item.
+	 * 
+	 * @param mode The new highlight mode.
+	 */
+	public void setHighlightMode(HighlightMode mode)
+	{
+		if (hasPermission(UserAppliedPermission.followLinks) || getEditTarget().hasPermission(UserAppliedPermission.followLinks)) {
+			if (_highlightMode != mode) {
+				_highlightMode = mode;
+				this.invalidateCommonTrait(ItemAppearence.HighlightModeChanged);
+			}
+		}
+	}
+	
+	public void setOverlayPermission(UserAppliedPermission overlayPermission)
+	{
 		_overlayPermission = overlayPermission;
 	}
 
-	public void setPermission(PermissionPair permissionPair) {
+	public void setPermission(PermissionPair permissionPair)
+	{
 		_permissionPair = permissionPair;
 	}
@@ -354,69 +512,4 @@
 	}
 
-	// A fill color of null represents transparent
-	private Color _colorFill = null;
-
-	// A gradient color of null represents NO gradient
-	private Color _colorGradient = null;
-
-	// A fore color of null represents the default color
-	private Color _color = null;
-
-	protected Color _highlightColor = DEFAULT_HIGHLIGHT;
-
-	private Color _colorBackground = null;
-
-	private Color _colorBorder = null;
-
-	private Color _colorTopShadow = null;
-
-	private Color _colorBottomShadow = null;
-
-	// the link\action circle
-	private Polygon _circle = null;
-
-	// the invalid link cross
-	private Polygon _circleCross = null;
-
-	private Frame _parent = null;
-	private Frame _oldParent = null;
-
-	protected int _highlightThickness = 2;
-
-	protected int _vectorHighlightThickness = 1;
-
-	// arrowhead parameters
-	private float  _arrowheadLength  = 0;
-	private double _arrowheadRatio   = DEFAULT_ARROWHEAD_RATIO;
-	private double _arrowheadNibPerc = DEFAULT_ARROWHEAD_NIB_PERC;
-	
-	private Polygon _arrowhead = null;
-
-	// the list of lines that this point is part of.
-	private List<Line> _lines = new ArrayList<Line>();
-
-	private int[] _linePattern = null;
-
-	private boolean _floating = false;
-
-	// list of points constrained with this point
-	private List<Constraint> _constraints = new ArrayList<Constraint>();
-
-	private List<String> _actions = null;
-
-	private List<String> _data = null;
-
-	private String _formula = null;
-
-	private String _link_frameset = null;
-
-	private String _link_template = null;
-
-	private String _fillPattern = null;
-
-	private boolean _visible = true;
-
-	private float _thickness = -1.0F;
-
 	protected Item() {
 		_creationDate = Formatter.getLongDateTime();
@@ -427,28 +520,30 @@
 	 * 
 	 * @param action
-	 *            The action to add to this Item
-	 */
-	public void addAction(String action) {
-		if (action == null || action.equals("")) {
-			return;
-		}
+	 *            The name of the action to add to this Item.
+	 */
+	public void addAction(String action)
+	{
+		if (action == null || action.equals("")) return;
 
 		if (_actions == null) {
 			_actions = new LinkedList<String>();
 		}
+		
 		_actions.add(action);
+		
 		if (_actions.size() == 1) {
-			_poly = null;
+			invalidateBounds();
 			invalidateCommonTrait(ItemAppearence.LinkChanged);
 		}
 	}
 
-	public void addAllConnected(Collection<Item> connected) {
-		if (!connected.contains(this))
-			connected.add(this);
+	public void addAllConnected(Collection<Item> connected)
+	{
+		if (!connected.contains(this)) connected.add(this);
 
 		for (Item item : getConnected()) {
-			if (!connected.contains(item))
+			if (!connected.contains(item)) {
 				item.addAllConnected(connected);
+			}
 		}
 	}
@@ -460,5 +555,6 @@
 	 *            The Constraint to set this Dot as a member of.
 	 */
-	public void addConstraint(Constraint c) {
+	public void addConstraint(Constraint c)
+	{
 		// do not add duplicate constraint
 		if (_constraints.contains(c))
@@ -474,5 +570,6 @@
 	 *            The Line that this Point is an end of.
 	 */
-	public void addLine(Line line) {
+	public void addLine(Line line)
+	{
 		if (_lines.contains(line)) {
 			return;
@@ -490,5 +587,6 @@
 	 *         less than, equal to, or greater than the specified object.
 	 */
-	public int compareTo(Item i) {
+	public int compareTo(Item i)
+	{
 		return getY() - i.getY();
 	}
@@ -499,13 +597,12 @@
 	 * the area and false otherwise.
 	 * 
-	 * @param x
-	 *            The x coordinate to check
-	 * @param y
-	 *            The y coordinate to check
+	 * @param p
+	 *            The coordinate to check
 	 * @return True if the Shape around this Item contains the given x,y pair,
 	 *         false otherwise.
 	 */
-	public boolean contains(int x, int y) {
-		return getPolygon().contains(x, y);
+	public boolean contains(Point p)
+	{
+		return getBounds().contains(p);
 	}
 
@@ -518,10 +615,12 @@
 	public abstract Item copy();
 
-	public void delete() {
+	public void delete()
+	{
 		_deleted = true;
 	}
 
 	@Override
-	public boolean equals(Object o) {
+	public boolean equals(Object o)
+	{
 		if (o == null)
 			return false;
@@ -542,29 +641,36 @@
 	 *         has been assigned.
 	 */
-	public List<String> getAction() {
+	public List<String> getAction()
+	{
 		return _actions;
 	}
 
-	public List<String> getData() {
+	public List<String> getData()
+	{
 		return _data;
 	}
 
-	public List<String> getActionCursorEnter() {
+	public List<String> getActionCursorEnter()
+	{
 		return _actionCursorEnter;
 	}
 
-	public List<String> getActionCursorLeave() {
+	public List<String> getActionCursorLeave()
+	{
 		return _actionCursorLeave;
 	}
 
-	public List<String> getActionEnterFrame() {
+	public List<String> getActionEnterFrame()
+	{
 		return _actionEnterFrame;
 	}
 
-	public List<String> getActionLeaveFrame() {
+	public List<String> getActionLeaveFrame()
+	{
 		return _actionLeaveFrame;
 	};
 
-	public boolean getActionMark() {
+	public boolean getActionMark()
+	{
 		return _actionMark;
 	}
@@ -576,5 +682,6 @@
 	 * @return
 	 */
-	public Collection<Item> getAllConnected() {
+	public Collection<Item> getAllConnected()
+	{
 		Collection<Item> list = new LinkedHashSet<Item>();
 		addAllConnected(list);
@@ -582,9 +689,10 @@
 	}
 
-	public Area getArea() {
+/*	public Area getArea() {
 		return new Area(getPolygon());
-	}
-
-	public String getArrow() {
+	}*/
+
+	public String getArrow()
+	{
 		if (!hasVisibleArrow())
 			return null;
@@ -597,25 +705,31 @@
 	}
 
-	public Polygon getArrowhead() {
+	public PolygonBounds getArrowhead()
+	{
 		return _arrowhead;
 	}
 
-	public float getArrowheadLength() {
+	public float getArrowheadLength()
+	{
 		return _arrowheadLength;
 	}
 
-	public double getArrowheadRatio() {
+	public double getArrowheadRatio()
+	{
 		return _arrowheadRatio;
 	}
 
-	public double getArrowheadNibPerc() {
+	public double getArrowheadNibPerc()
+	{
 		return _arrowheadNibPerc;
 	}
 	
-	public Color getBackgroundColor() {
-		return _colorBackground;
-	}
-
-	public Color getBorderColor() {
+	public Colour getBackgroundColor()
+	{
+		return _backgroundColour;
+	}
+
+	public Colour getBorderColor()
+	{
 		return _colorBorder;
 	}
@@ -628,5 +742,6 @@
 	 *         border.
 	 */
-	public Color getBottomShadowColor() {
+	public Colour getBottomShadowColor()
+	{
 		return _colorBottomShadow;
 	}
@@ -638,6 +753,7 @@
 	 *         returned by getArea().
 	 */
-	public int getBoundsHeight() {
-		return getPolygon().getBounds().height;
+	public int getBoundsHeight()
+	{
+		return AxisAlignedBoxBounds.getEnclosing(getBounds()).getHeight();
 	}
 
@@ -648,60 +764,51 @@
 	 *         by getArea().
 	 */
-	public int getBoundsWidth() {
-		return getPolygon().getBounds().width;
-	}
-
-	// TODO draw the link with a circle rather than a polygon!!
-	public Polygon getLinkPoly() {
-		if (_circle == null) {
-			int points = 16;
-
-			double radians = 0.0;
-			int xPoints[] = new int[points];
-			int yPoints[] = new int[xPoints.length];
-
-			for (int i = 0; i < xPoints.length; i++) {
-				// circle looks best if these values are not related to gravity
-				xPoints[i] = (int) (3.5 * Math.cos(radians)) + 6;// (2 *
-				// GRAVITY);
-				yPoints[i] = (int) (3.5 * Math.sin(radians)) + 3;// GRAVITY;
-				radians += (2.0 * Math.PI) / xPoints.length;
-			}
-
-			_circle = new Polygon(xPoints, yPoints, xPoints.length);
-		}
-
-		return _circle;
-	}
-
-	protected Polygon getCircleCross() {
-
-		if (_circleCross == null) {
-			_circleCross = new Polygon();
-
-			Rectangle bounds = getLinkPoly().getBounds();
-			int x1 = (int) bounds.getMinX();
-			int x2 = (int) bounds.getMaxX();
-			int y1 = (int) bounds.getMinY();
-			int y2 = (int) bounds.getMaxY();
-			int midX = ((x2 - x1) / 2) + x1;
-			int midY = ((y2 - y1) / 2) + y1;
-
-			_circleCross.addPoint(x1, y1);
-			_circleCross.addPoint(x2, y2);
-			_circleCross.addPoint(midX, midY);
-			_circleCross.addPoint(x1, y2);
-			_circleCross.addPoint(x2, y1);
-			_circleCross.addPoint(midX, midY);
-		}
-
-		return _circleCross;
-	}
-
-	public Color getColor() {
-		return _color;
-	}
-
-	public Collection<Item> getConnected() {
+	public int getBoundsWidth()
+	{
+		return AxisAlignedBoxBounds.getEnclosing(getBounds()).getWidth();
+	}
+
+	// TODO: Remove magic constants. cts16
+	public EllipticalBounds getLinkBounds()
+	{
+		if (_linkCircle == null) {
+			_linkCircle = new EllipticalBounds(new Point(6, 3), 7);
+		}
+
+		return _linkCircle;
+	}
+
+	protected PolygonBounds getCircleCross()
+	{
+
+		if (_linkCircleCross == null) {
+			_linkCircleCross = new PolygonBounds();
+
+			EllipticalBounds poly = getLinkBounds();
+			int x1 = poly.getMinX();
+			int x2 = poly.getMaxX();
+			int y1 = poly.getMinY();
+			int y2 = poly.getMaxY();
+			int midX = (x2 + x1) / 2;
+			int midY = (y2 + y1) / 2;
+
+			_linkCircleCross.addPoint(new Point(x1, y1));
+			_linkCircleCross.addPoint(new Point(x2, y2));
+			_linkCircleCross.addPoint(new Point(midX, midY));
+			_linkCircleCross.addPoint(new Point(x1, y2));
+			_linkCircleCross.addPoint(new Point(x2, y1));
+			_linkCircleCross.addPoint(new Point(midX, midY));
+		}
+
+		return _linkCircleCross;
+	}
+
+	public Colour getColor()
+	{
+		return _foregroundColour;
+	}
+
+	public Collection<Item> getConnected()
+	{
 		List<Item> conn = new LinkedList<Item>();
 		conn.add(this);
@@ -711,5 +818,6 @@
 	}
 
-	public String getConstraintIDs() {
+	public String getConstraintIDs()
+	{
 		if (_constraints == null || _constraints.size() == 0)
 			return null;
@@ -732,9 +840,11 @@
 	 * @return a List of Constraints that this Dot is a member of.
 	 */
-	public List<Constraint> getConstraints() {
+	public List<Constraint> getConstraints()
+	{
 		return _constraints;
 	}
 
-	public String getTag() {
+	public String getTag()
+	{
 		if (_tag != null && _tag.length() > 0)
 			return _tag.toString();
@@ -742,17 +852,21 @@
 	}
 
-	public String getDateCreated() {
+	public String getDateCreated()
+	{
 		return _creationDate;
 	}
 
-	public Color getFillColor() {
-		return _colorFill;
-	}
-
-	public String getFillPattern() {
+	public Colour getFillColor()
+	{
+		return _fillColour;
+	}
+
+	public String getFillPattern()
+	{
 		return _fillPattern;
 	}
 
-	public String getFirstAction() {
+	public String getFirstAction()
+	{
 		if (_actions == null || _actions.size() == 0)
 			return null;
@@ -760,11 +874,19 @@
 	}
 
-	public boolean getHighlight() {
+	/**
+	 * Gets the value of <code>_highlight</code> for this item.
+	 * TODO: Appears unused? cts16.
+	 * 
+	 * @return The value of <code>_highlight</code>.
+	 */
+	public boolean getHighlight()
+	{
 		return _highlight;
 	}
 
-	public Color getHighlightColor() {
-		if (_highlightColor.equals(getPaintColor()))
-			return getAlternateHighlightColor();
+	public Colour getHighlightColor()
+	{
+		if (_highlightColour.equals(getPaintColor())) return getAlternateHighlightColor();
+		
 		return getDefaultHighlightColor();
 	}
@@ -774,6 +896,9 @@
 	 * 
 	 * @return The ID of this Item.
-	 */
-	public int getID() {
+	 * 
+	 * TODO: What does it mean to have a negative ID# (as used in TDFC)? cts16
+	 */
+	public int getID()
+	{
 		return _id;
 	}
